DCMTK: DiMonoScaleTemplate< T > Class Template Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | List of all members
DiMonoScaleTemplate< T > Class Template Reference

Template class to scale monochrome images (on pixel data level). More...

Inheritance diagram for DiMonoScaleTemplate< T >:

## Public Member Functions
| DiMonoScaleTemplate (const DiMonoPixel *pixel, const Uint16 columns, const Uint16 rows, const signed long left_pos, const signed long top_pos, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames, const int bits, const int interpolate, const Uint16 pvalue)
| constructor
virtual | ~DiMonoScaleTemplate ()
| destructor
Public Member Functions inherited from DiMonoPixelTemplate< T >
| DiMonoPixelTemplate (const unsigned long count)
| constructor
| DiMonoPixelTemplate (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixelTemplate (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor
virtual | ~DiMonoPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation
const void * | getData () const
| get pointer to internal pixel data
void * | getDataPtr ()
| get pointer to internal pixel data
void * | getDataArrayPtr ()
| get reference to pointer to internal pixel data.
int | getMinMaxValues (double &min, double &max) const
| get minimum and maximum pixel values
int | getMinMaxWindow (const int idx, double &center, double &width)
| get automatically computed min-max window
virtual int | getRoiWindow (const unsigned long left_pos, const unsigned long top_pos, const unsigned long width, const unsigned long height, const unsigned long columns, const unsigned long rows, const unsigned long frame, double &voiCenter, double &voiWidth)
| get automatically computed Region of Interest (ROI) window
int | getHistogramWindow (const double thresh, double &center, double &width)
| get automatically computed histogram window
Public Member Functions inherited from DiMonoPixel
| DiMonoPixel (const unsigned long count)
| constructor
| DiMonoPixel (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixel (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor
virtual | ~DiMonoPixel ()
| destructor
int | getPlanes () const
| get number of planes
unsigned int | getBits () const
| get number of bits per pixel
double | getAbsMinimum () const
| get absolute minimum pixel value.
double | getAbsMaximum () const
| get absolute maximum pixel value.
double | getAbsMaxRange () const
| get absolute pixel range
const char * | getModalityLutExplanation () const
| get modality LUT explanation string
DiMonoModality * | addReferenceToModality ()
| add a reference to the internally managed modality transform object
int | isPotentiallySigned () const
| check whether pixel data is 'potentially' signed.
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element
Public Member Functions inherited from DiPixelRepresentationTemplate< T >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not

## Private Member Functions
void | scale (const T *pixel, const unsigned int bits, const int interpolate, const Uint16 pvalue)
| scale pixel data

## Additional Inherited Members
Protected Member Functions inherited from DiMonoPixelTemplate< T >
| DiMonoPixelTemplate (const DiPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixelTemplate (const DiMonoPixel *pixel, const unsigned long count)
| constructor
void | determineMinMax (T minvalue=0, T maxvalue=0, const int mode=0x1)
| determine minimum and maximum pixel values
Protected Member Functions inherited from DiMonoPixel
| DiMonoPixel (const DiPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixel (const DiMonoPixel *pixel, const unsigned long count)
| constructor
Protected Member Functions inherited from DiScaleTemplate< T >
| DiScaleTemplate (const int planes, const Uint16 columns, const Uint16 rows, const signed long left_pos, const signed long top_pos, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames, const int bits=0)
| constructor, scale clipping area.
| DiScaleTemplate (const int planes, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames, const int bits=0)
| constructor, scale whole image.
virtual | ~DiScaleTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not
void | scaleData (const T *src[], T *dest[], const int interpolate, const T value=0)
| choose scaling/clipping algorithm depending on specified parameters.
Protected Member Functions inherited from DiTransTemplate< T >
| DiTransTemplate (const int planes, const Uint16 src_x, const Uint16 src_y, const Uint16 dest_x, const Uint16 dest_y, const Uint32 frames, const int bits=0)
| constructor
virtual | ~DiTransTemplate ()
| destructor
void | copyPixel (const T *src[], T *dest[])
| copy pixel data
void | fillPixel (T *dest[], const T value)
| fill pixel data with specified value
void | clearPixel (T *dest[])
| clear pixel data (set values to 0)
Protected Attributes inherited from DiMonoPixelTemplate< T >
T * | Data
| pointer to pixel data
Protected Attributes inherited from DiMonoPixel
DiMonoModality * | Modality
| pointer to modality transform object
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer
Protected Attributes inherited from DiScaleTemplate< T >
const signed long | Left
| left coordinate of clipping area
const signed long | Top
| top coordinate of clipping area
const Uint16 | Columns
| width of source image
const Uint16 | Rows
| height of source image
Protected Attributes inherited from DiTransTemplate< T >
int | Planes
| number of planes
Uint16 | Src_X
| width of source image
Uint16 | Src_Y
| height of source image
const Uint16 | Dest_X
| width of destination image
const Uint16 | Dest_Y
| height of destination image
const Uint32 | Frames
| number of frames
const int | Bits
| number of bits per plane/pixel

## Detailed Description

template<class T>
class DiMonoScaleTemplate< T >

Template class to scale monochrome images (on pixel data level).

## Constructor & Destructor Documentation

## ◆ DiMonoScaleTemplate()

template<class T>

DiMonoScaleTemplate< T >::DiMonoScaleTemplate | ( | const DiMonoPixel * | pixel,
|  | const Uint16 | columns,
|  | const Uint16 | rows,
|  | const signed long | left_pos,
|  | const signed long | top_pos,
|  | const Uint16 | src_cols,
|  | const Uint16 | src_rows,
|  | const Uint16 | dest_cols,
|  | const Uint16 | dest_rows,
|  | const Uint32 | frames,
|  | const int | bits,
|  | const int | interpolate,
|  | const Uint16 | pvalue )
| inline

constructor

Parameters

  pixel | pointer to intermediate pixel representation
  columns | width of source image
  rows | height of source image
  left_pos | left coordinate of clipping area
  top_pos | top coordinate of clipping area
  src_cols | width of clipping area
  src_rows | height of clipping area
  dest_cols | width of destination image (scaled image)
  dest_rows | height of destination image
  frames | number of frames
  bits | number of bits per plane/pixel
  interpolate | use of interpolation when scaling
  pvalue | value possibly used for regions outside the image boundaries

References DiMonoPixel::DiMonoPixel(), DiMonoPixelTemplate< T >::DiMonoPixelTemplate(), DiScaleTemplate< T >::DiScaleTemplate(), and DiPixel::getCount().

## Member Function Documentation

## ◆ scale()

template<class T>

void DiMonoScaleTemplate< T >::scale | ( | const T * | pixel,
|  | const unsigned int | bits,
|  | const int | interpolate,
|  | const Uint16 | pvalue )
| inlineprivate

scale pixel data

Parameters

  pixel | pointer to pixel data to be scaled
  bits | bit depth of pixel data
  interpolate | use of interpolation when scaling
  pvalue | value possibly used for regions outside the image boundaries

References DiMonoPixelTemplate< T >::Data, DiPixel::getCount(), DicomImageClass::maxval(), and DiScaleTemplate< T >::scaleData().

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/dimosct.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2